/*
 * Copyright (C) 2003  Diez B. Roggisch [deets@web.de]
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: FilterContext.java 114 2005-12-09 15:51:51Z christianc $
 */
package org.barracudamvc.contrib.dbroggisch.display.filters;

import java.util.Locale;

import org.barracudamvc.core.view.ViewCapabilities;
import org.barracudamvc.plankton.data.DefaultStateMap;

public class FilterContext extends DefaultStateMap {
    public static final String FILTER_LOCALE = "DefaultStateMap.FILTER_LOCALE";


    public String _channel;


    public FilterContext() {
        this(Locale.getDefault());
    }

    public FilterContext(Locale loc) {
        setLocale(loc);
    }

    public FilterContext(ViewCapabilities vc) {
        this(vc.getClientLocale());
    }


    public String getChannel() {
        return _channel;
    }

    public void setChannel(String channel) {
        _channel = channel;
    }


    public Locale getLocale() {
        return (Locale)getState(FILTER_LOCALE);
    }

    public void setLocale(Locale loc) {
        putState(FILTER_LOCALE, loc);
    }

}
