/*
 * Copyright (C) 2003  Diez B. Roggisch [deets@web.de]
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: DummyPageHandler.java 114 2005-12-09 15:51:51Z christianc $
 */
package org.barracudamvc.contrib.dbroggisch.page;

import java.io.IOException;

import javax.servlet.ServletException;

import org.apache.log4j.Logger;
import org.barracudamvc.core.event.ControlEventContext;
import org.barracudamvc.core.event.EventException;


/**
 * A simple convenience class providing a dummy page request handler for events
 * meant to do nothing more than load a page. The only thing that actually
 * happens is that the event is flagged as having been handled.
 *
 * @author <a href="mailto:deets@web.de">Diez B. Roggisch</a>
 * @version 1.0
 */
public class DummyPageHandler extends PageEventListener {

    private static final Logger logger = Logger.getLogger(DummyPageHandler.class.getName());

    public void handleControlEvent(ControlEventContext context, Page page)
            throws EventException, ServletException, IOException {
        context.getEvent().setHandled(true);
        if (logger.isDebugEnabled()) logger.debug("Event " + context.getEvent().getClass().getName() + " associated with Page " + page.getClass().getName() + " set as handled");
    }

}
