/*
 * Copyright (C) 2003  Diez B. Roggisch [deets@web.de]
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: CheckboxFormElement.java 114 2005-12-09 15:51:51Z christianc $
 */
package org.barracudamvc.contrib.dbroggisch.repopulation;

import org.barracudamvc.core.comp.BToggleButton;
import org.barracudamvc.core.comp.ViewContext;
import org.barracudamvc.core.forms.DefaultFormElement;
import org.barracudamvc.core.forms.FormType;
import org.barracudamvc.core.forms.ParseException;

public class CheckboxFormElement extends DefaultFormElement implements RepopulationElement {

    public CheckboxFormElement(java.lang.String name, org.barracudamvc.core.forms.FormType ft) {
        // TODO: Check if , new Boolean(false) as default makes sense
        super(name, ft, null);
    }


    public Object render(ViewContext context) {
        BToggleButton btog = new BToggleButton();
        btog.setName(getName());
        Object val = getOrigVal();

        if(val != null && val instanceof Boolean) {
            btog.setSelected(((Boolean)val).booleanValue());
        } else if(val instanceof String) {
            try {
                Boolean bVal = (Boolean)FormType.BOOLEAN.parse((String)val);
                btog.setSelected(bVal.booleanValue());
            }
            catch(ParseException ex) {
                if(logger.isDebugEnabled()) {
                    logger.debug("Parsing of " + val + " to Boolean failed");
                }
            }
        }
        return btog;
    }
}

