/*
 * Copyright (C) 2003  Diez B. Roggisch [deets@web.de]
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: FileUploadPage.java 114 2005-12-09 15:51:51Z christianc $
 */
package org.barracudamvc.contrib.dbroggisch.examples.view.pages;

import java.io.IOException;
import java.util.List;
import java.util.Locale;
import javax.servlet.ServletException;
import org.w3c.dom.Document;
//import org.enhydra.xml.xmlc.XMLCStdFactory;
import org.barracudamvc.core.comp.BComponent;
import org.barracudamvc.core.comp.BList;
import org.barracudamvc.core.comp.DefaultListModel;
import org.barracudamvc.core.comp.DefaultView;
import org.barracudamvc.core.comp.ViewContext;
import org.barracudamvc.core.event.EventException;
import org.barracudamvc.core.util.dom.DefaultDOMLoader;
import org.apache.log4j.Logger;

import org.barracudamvc.contrib.dbroggisch.examples.view.xmlc.*;


public class FileUploadPage extends ExampleBasePage {

    private static final Logger logger = Logger.getLogger(FileUploadPage.class.getName());

    List _names;

    public void setNames(List names) {
        _names = names;
    }

    public void render(BComponent root, ViewContext vec, Document pDoc)
            throws EventException, ServletException, IOException {
        super.render(root, vec, pDoc);
        FileUploadHTML doc = (FileUploadHTML)pDoc;
        BList fList = new BList();
        fList.setView(new DefaultView(doc.getElementFileNames()));
        DefaultListModel dlm = new DefaultListModel();
        dlm.addAll(_names);
        fList.setModel(dlm);
        root.addChild(fList);
    }

    public Document getDocument(Locale iLocale) {
        //return new XMLCStdFactory(null, null).create(FileUploadHTML.class);

        Document doc = null;
        //load the localized DOM template
        try {doc = DefaultDOMLoader.getGlobalInstance().getDOM(FileUploadHTML.class, iLocale);}
        catch (IOException ioe) {logger.fatal ("Fatal Error loading DOM template:", ioe);}
        return doc;
    }

}
