/*
 * Copyright (C) 2003  Stefan Armbruster [stefan@armbruster-it.de]
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: Config.java 114 2005-12-09 15:51:51Z christianc $
 */
package org.barracudamvc.contrib.sam.data;

import org.barracudamvc.core.event.ViewEvent;

/** Interface for a confiugration class. Used in {@link DataObjectHandler }. It
 * specifies various properties of a {@link DataObject} based {@link org.barracudamvc.contrib.sam.xmlform.XmlFormMap }
 */
public interface Config {

    public String MAP = "MAP";
    public String OID = "oid";

    /** returns a view event called for displaying the form */
    public ViewEvent getViewEvent();
    /**
     * @return name of the XML Form, this string is used by {@link org.barracudamvc.contrib.sam.xmlform.XmlFormFactory}
     */
    public String getXmlFormName() ;
    public String getFormName();
    public String getMapName() ;
    /**
     * @return name of the identifier field in the {@link DataObject}
     */
    public String getOidName() ;
    /**
     * @return data object identified by the given oid. Normally, this would be implemented by
     * a SQL query
     */
    public DataObject getDataObject(String oid) throws DataObjectException;
}
