/*
 * Copyright (C) 2003  Christian Cryder [christianc@granitepeaks.com]
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: SampleApplicationGateway.java 114 2005-12-09 15:51:51Z christianc $
 */
package org.barracudamvc.examples;

import org.barracudamvc.core.event.ApplicationGateway;
import org.barracudamvc.examples.ex3.TestScreen;
//import org.barracudamvc.examples.ex1.LocalUtilities;

/**
 * <p>This is the gateway for the EventHandler7 apps. Right now,
 * this is just the Simple Login app (LoginGateway). If there
 * were other apps that needed to use the gateway, we'd add them 
 * here as well.
 *
 * <p>You might want to look at the <a href="simple_login.gif">UML Class 
 * diagram for the Simple Login app.</a> or check out 
 * <a href="simple_login_app.html">Understanding the Simple Login App</a>
 */
public class SampleApplicationGateway extends ApplicationGateway {

    //-------------------- ApplicationGateway --------------------
    /**
     * Perform any local initialization (this is where you should
     * add any other known EventGateways)
     */
//csc_100901.1    public void initializeLocal(ServletConfig config) {
    public void initializeLocal() {
        //specify the event gateways
        this.specifyEventGateways(new GlobalUtilities());
//        this.specifyEventGateways(new LoginGateway());
        this.specifyEventGateways(new TestScreen());
    }
}

