/*
 * Copyright (C) 2003  Christian Cryder [christianc@granitepeaks.com]
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: SampleControlHandler.java 114 2005-12-09 15:51:51Z christianc $
 */
package org.barracudamvc.examples.ex4;

import java.io.IOException;

import javax.servlet.ServletException;

import org.barracudamvc.core.event.BaseEventListener;
import org.barracudamvc.core.event.ControlEventContext;
import org.barracudamvc.core.event.DefaultBaseEventListener;
import org.barracudamvc.core.event.DefaultListenerFactory;
import org.barracudamvc.core.event.EventException;
import org.barracudamvc.examples.ex4.events.RenderEvent;


/**
 * A sample control event handler
 */
public class SampleControlHandler extends DefaultListenerFactory {

    private String name = null;
    public String name1 = null;
    public static String name2 = null;
    public boolean sboolean = false;
    // RTL - jikes error public byte sbyte = ' ';
    public byte sbyte = 0;
    public char schar = ' ';
    public double sdouble = -1;
    public float sfloat = 1.0F;
    public int sint = -1;
    public long slong = -1;
    public short sshort = -1;

    //define the necessary factory methods
    public BaseEventListener getInstance() {
        return new TestHandler();
    }            
    public String getListenerID() {
        return getID(TestHandler.class);
    }

    //provide sample hooks to set values
    public void setName(String iname) {
        name = iname;
    }
    public void setSBoolean(boolean val) {
        sboolean = val;
    }
    public void setSByte(byte b) {
        sbyte = b;
    }
    public void setSChar(char c) {
        schar = c;
    }
    public void setSDouble(double d) {
        sdouble = d;
    }
    public void setSFloat(float f) {
        sfloat = f;
    }
    public void setSInt(int i) {
        sint = i;
    }
    public void setSLong(long l) {
        slong = l;
    }
    public void setSShort(short s) {
        sshort = s;
    }
    
    //------------------------------------------------------------
    //             Model 2 - Controller Event Handlers
    //------------------------------------------------------------
    /**
     * TestHandlers - handle the request to get the test
     * screen.
     */
    class TestHandler extends DefaultBaseEventListener {
        public void handleControlEvent(ControlEventContext context) throws EventException, ServletException, IOException {
            //in this case, we're not really doing anything special, so just
            //redirect to the RenderLogin view
            context.putState(SampleViewHandler.HANDLED_BY, name);
            context.getQueue().addEvent(new RenderEvent(context.getEvent()));
        }
    }
}

