package org.barracudamvc.examples.xmlc.data;

import java.util.HashMap;

public class UserData extends HashMap implements Cloneable {

    private boolean newrec = true;
    private boolean dirty = false;

    //define basic ROW types
    public static final String SELECTED = "Selected";        //Boolean
    public static final String FIRST_NAME = "FirstName";    //String
    public static final String LAST_NAME = "LastName";        //String
    public static final String GENDER = "Gender";            //Boolean (true=male)
    public static final String AGE = "Age";                    //Integer
    public static final String EMAIL = "Email";                //String
    public static final String PHONE = "Phone";                //String
    public static final String NOTES = "Notes";                //String
    
    public UserData() {
        put(UserData.SELECTED, new Boolean(false));
        put(UserData.FIRST_NAME, "");
        put(UserData.LAST_NAME, "");
        put(UserData.GENDER, new Boolean(true));
        put(UserData.AGE, new Integer(0));
        put(UserData.EMAIL, "");
        put(UserData.PHONE, "");
        put(UserData.NOTES, "");
        setNew(true);
        setDirty(false);
    }

    /**
     * set data in the store
     */    
    public Object put(Object key, Object value) {
        setDirty(true);
        return super.put(key, value);
    }
    
    /**
     * mark this data record as new
     */
    public void setNew(boolean val) {
        newrec = val;
    }
    
    /**
     * Is this data record new
     */
    public boolean isNew() {
        return newrec;
    }
    
    /**
     * mark this data record dirty/clean
     */
    public void setDirty(boolean val) {
        dirty = val;
    }
    
    /**
     * Is this data record dirty
     */
    public boolean isDirty() {
        return dirty;
    }
    
    /**
     * Make a copy of the current object
     */
    public Object clone() {
        return super.clone();
    }
}

